//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005 Adam Judson
//
//  PhotoMap
//  - display user contributed photos on maps.
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


//
// PhotoMapLang is the object we use to set language strings from the properties file
//
//
function PhotoMapLang() {
   this.init();
}

PhotoMapLang.instance = function() {
   if (!PhotoMapLang.myInstance) {
      PhotoMapLang.myInstance = new PhotoMapLang();
   }
   return PhotoMapLang.myInstance;
}


PhotoMapLang.STRING_BUNDLE = "chrome://photomap/locale/PhotoMap.properties";

PhotoMapLang.prototype = {
   init : function() {
      var service = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
      this.stringBundle = service.createBundle(PhotoMapLang.STRING_BUNDLE);
   },

   getString : function(key) {
      var value = key;
      try {
         value = this.stringBundle.GetStringFromName(key);
      } catch (e) {
         PhotoMapUtils.log("Translation not found for: " + key);
         window.alert("Translation not found for: " + key);
      }
      return value;
   },

   getMessage : function(key, parameters) {
      var message = this.getString(key);
      for (param in parameters) {
         if (parameters[param]) {
            var regExp = new RegExp("%" + param, "g");
            message = message.replace(regExp, parameters[param]);
         }
      }
      return message;
   }
}

function PhotoMapLanguage(prefix) {
   this.langPrefix = prefix;
}

PhotoMapLanguage.prototype = {
   langString : function(key) {
      return PhotoMapLang.instance().getString(this.langPrefix + key);
   },

   langMessage : function(key, parameters) {
      return PhotoMapLang.instance().getMessage(this.langPrefix + key, parameters);
   }
}